/*
Copyright (C) 2000 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "ckDialog.h"

auto_ptr<ckLogger> ckLogger::_instance;


ckLogger *ckLogger::instance()
{
    if(_instance.get() == NULL)
    {
        _instance.reset(new ckMsgBoxLogger);
    }

    assert(_instance.get());
    return _instance.get();
}


inline void ckMsgBoxLogger::log(ckError code, string const &message)
{
    ::MessageBox(NULL, message.c_str(), ckErrorStringArray[code], MB_OK | MB_ICONERROR);
}