/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CK_VALUEWRAPPER_H_
#define _CK_VALUEWRAPPER_H_

#include "ckDialog.h"

class ckBaseScanner;

class ckValueWrapper
{
public:
    ckValueWrapper(ckBaseScanner &scanner);

    virtual ~ckValueWrapper() {}

    string getCurrentString();

    ckError getRawStringWithLength(string &str);
    ckError getRawString(string &str);
    ckError getStringWithLength(string &str, bool var = true);
    ckError getString(string &str, bool var = true);

    ckError getInt(int &num);
    ckError getInt(long &num);
    ckError getVariableInt(int &num, string &str);
    ckError getVariableInt(long &num, string &str);

    ckBaseScanner &getScanner();

protected:
    ckBaseScanner &_scanner;
};



#endif