/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CK_VARIABLES_H_
#define _CK_VARIABLES_H_

#include "ckDialog.h"
#include "ckControl.h"
#include "ckStream.h"
#include "ckScanner.h"
#include "ckControlManager.h"


//
// ckVariables
//
class ckVariables
{
public:
    static ckVariables *instance();

    virtual ~ckVariables();

    ckError translateVariable(string &str, ckControl *control = NULL);

protected:
    
    static auto_ptr<ckVariables> _instance;
};


//
// ckVariableReplacer
//
class ckVariableReplacer
{
public:
    ckVariableReplacer() {}
    virtual ~ckVariableReplacer() {}

    virtual string replace(ckStream &stream);
protected:
    virtual string _replace(string const &var) = 0;
};

class ckGlobalVariableReplacer : public ckVariableReplacer
{

protected:
    virtual string _replace(string const &var);
};

#endif