/*
Copyright (C) 2001 Chao-Kuo Lin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CK_VISITOR_H_
#define _CK_VISITOR_H_

#include "ckDialog.h"

class ckControl;

class ckVisitor
{
public:
    ckVisitor();
    virtual ~ckVisitor();

    // did we fail to visit gramma?
    virtual bool visit(ckControl &control) = 0;
};


//
// wholeworld visitor 
//
// should change to traverser

class ckCreateWindowVisitor
{
public:
    ckCreateWindowVisitor();
    virtual ~ckCreateWindowVisitor();

    virtual bool visit(ckControl &control)
    {
        _classname = control.getAttribute(TYPE_ATTRIB);
        return _createwindow(control);
    }

    virtual bool visitDialog(ckDialogControl &control)
    {
        _classname = control.getClassName();
        return _createwindow(control);
    }

protected:

    bool _createwindow(ckControl &control)
    {
        // first we need to check for validity of the attributes
        // and classname
        RECT r;
        DWORD style;
        DWORD xstyle;
        assert(!control.getHWND());

        ckSizeParser sizeparser(r);
        if(sizeparser.parse(ckStrStream(control.getAttribute(SIZE_ATTRIB))))
        {
            // now r is the size of our window
            ckStyleParser styleparser(style, control.getstylegallery());
            if(styleparser.parse(ckStrStream(control.getAttribute(STYLE_ATTRIB))))
            {// now we got the style
                ckXStyleParser xstyleparser(xstyle, control.getxstylegallery());
                if(xstyleparser.parse(ckStrStream(control.getAttribute(XSTYLE_ATTRIB))))
                {// now we got the xstyle
                        control.createwindow(
                                        xstyle,
                                        _classname,
			                            control.getAttribute(TITLE_ATTRIB).c_str(),
                                        style,
			                            r.left,                                     
			                            r.top,                                      
			                            r.right,                                    
			                            r.bottom,                                   
                                        control.parentHWND(),                               
			                            NULL,                                       
                                        ckControl::_hInstance,                                 
			                            (LPVOID)(&control)
		                            );
                    
                }
            }
        }
        
        return control.getHWND();
    }

    string _classname;
};




#endif

